# Copyright (C) 2010-2014 Simula Research Laboratory
#
# This file is part of CBCFLOW.
#
# CBCFLOW is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# CBCFLOW is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with CBCFLOW. If not, see <http://www.gnu.org/licenses/>.
from cbcflow.dol import FacetNormal, as_vector, dot, assemble, Constant, ds

def compute_resistance_value(C, u, ind, facet_domains):
    mesh = facet_domains.mesh()
    dsi = ds[facet_domains](ind)
    n = FacetNormal(mesh)
    u = as_vector(u)
    form = dot(u, n)*dsi
    return C*assemble(form)

# TODO: [martin] don't understand this design, why subclassing Constant?
class Resistance(Constant):
    def __init__(self, C, u, ind, facet_domains):
        Constant.__init__(self, compute_resistance_value(C, u, ind, facet_domains))
